# generic player camera, gets the point 1 meter above the ground that the mouse is over

extends Camera

const ray_length = 1000000

func _ready():
	get_tree().call_group("mirror_cameras", "set_main_cam", self)

func _process(_delta):
	get_tree().call_group("mirror_cameras", "update")

func get_point_under_mouse():
	var m_pos = get_viewport().get_mouse_position()
	var from = project_ray_origin(m_pos)
	var to = from + project_ray_normal(m_pos) * ray_length
	
	var n = Vector3(0, 1, 0) #ground plane normal
	var p = Vector3(0, 1.5, 0) #base of plane to intersect, one unit higher since gun is higher on player
	#ray plane intersection equation
	var t = (p - from).dot(n) / (to.dot(n))
	
	return t * to + from