extends Panel

onready var texture_rect = $TextureRect
var item_hotkeyyed_here = null
signal hotkey_set

func _ready():
	$Label.text = str(get_index() + 1)

func insert_item(item):
	if !ItemDB.is_weapon(item.id):
		return false
	if item_hotkeyyed_here != null:
		clear()
	if item.hotkey_slot != null:
		item.hotkey_slot.clear()
	item.hotkey_slot = self
	item.hotkey_slot_id = get_index()
	item_hotkeyyed_here = item
	texture_rect.show()
	var item_data = ItemDB.get_item(item.id)
	if "hotkey_icon" in item_data:
		texture_rect.texture = load(item_data.hotkey_icon)
	else:
		texture_rect.texture = load(item_data.icon)
	emit_signal("hotkey_set", get_index(), item.id)
	return false

func clear():
	if item_hotkeyyed_here == null:
		return
	var tmp_item_hotkeyyed_here = item_hotkeyyed_here
	item_hotkeyyed_here = null
	tmp_item_hotkeyyed_here.clear_hotkey()
	texture_rect.hide()
	emit_signal("hotkey_set", get_index(), "")
	