extends Panel

var item_in_slot = null
signal hotkey_set

func insert_item(item):
	if item_in_slot != null:
		return false
	if !ItemDB.is_weapon(item.id):
		return false
	var item_pos = item.rect_global_position + item.rect_size / 2
	if not get_global_rect().has_point(item_pos):
		return false
	
	item_in_slot = item
	if item.rotated:
		item.rotate(item.rect_global_position)
	item.rect_global_position = rect_global_position + rect_size / 2 - item.rect_size / 2
	emit_signal("hotkey_set", get_index(), item.id)
	return true

func peek_item(pos):
	if item_in_slot != null and item_in_slot.get_global_rect().has_point(pos):
		return item_in_slot

func grab_item(pos):
	if not get_global_rect().has_point(pos):
		return null
	var item = item_in_slot
	item_in_slot = null
	emit_signal("hotkey_set", get_index(), "")
	return item

func _load(item_id, item_parent):
	if item_id == "":
		return
	if item_in_slot != null:
		item_in_slot.queue_free()
		item_in_slot = null
	var item = ItemDB.create_item_for_ui(item_id, item_parent)
	var item_pos = rect_global_position + rect_size / 2 - item.rect_size / 2
	item.rect_global_position = item_pos
	if not insert_item(item):
		print("error loading main hand")
		item.queue_free()
	
	