extends Control

var items = {}
var mat = preload("res://characters/player/inventory/SpriteOutlineMat.tres")

export var verbose = false

func add_item(item: ItemUI):
	if verbose:
		print("add item")
	var new_item_ui = TextureRect.new()
	add_child(new_item_ui)
	new_item_ui.texture = item.hard_texture.texture
	new_item_ui.rect_global_position = item.rect_global_position
	if item.rotated:
		new_item_ui.rect_rotation = 90
		new_item_ui.rect_global_position.x += item.rect_size.x
	
	new_item_ui.rect_size = item.rect_size
	new_item_ui.light_mask = 2
	new_item_ui.material = mat
	#new_item_ui.modulate.a = 0.8
	items[str(item)] = new_item_ui

func remove_item(item: ItemUI):
	if verbose:
		print("remove item")
	items[str(item)].queue_free()
	items.erase(str(item))

func clear_items():
	for item in items.values():
		item.queue_free()
		items = {}