extends Particles

const NUM_OF_DECALS = 8
const min_max_decal_scale = Vector2(0.2, 0.8)
const decal_cast_dist = 8.0

var grnd_splatter = preload("GroundBloodSplatter.tscn")
var grnd_splatter_water = preload("GroundBloodSplatterWater.tscn")

func init():
	create_ground_splatter()
	emitting = true
	cast_decals()

func create_ground_splatter():
	var grnd_spt = grnd_splatter_water.instance()
	grnd_spt.get_node("MeshInstance").set_surface_material(0, grnd_spt.get_node("MeshInstance").get_surface_material(0).duplicate())
	get_tree().get_root().add_child(grnd_spt)
	var pos = global_transform.origin
	pos.y = 0.005
	grnd_spt.global_transform.origin = pos
	grnd_spt.rotation.y = rotation.y
	
	EnvironmentDecalManager.place_blood_floor_decal(pos, Vector3.UP, 3.0, rotation.y, -2.0 * Vector3.FORWARD.rotated(Vector3.UP, rotation.y))


func cast_decals():
	var space_state = get_world().direct_space_state
	var our_pos = global_transform.origin + Vector3(0.0, 1.5, 0.0)
	for i in range(NUM_OF_DECALS):
		var x_rot = lerp(60.0, -15.0, i*1.0 / NUM_OF_DECALS) + rand_range(0.0, 5.0)
		var y_rot = rand_range(-45.0, 45.0)
		var cast_to = Vector3.BACK
		cast_to = decal_cast_dist * cast_to.rotated(Vector3.RIGHT, deg2rad(x_rot)).rotated(Vector3.UP, deg2rad(y_rot))
		var result = space_state.intersect_ray(our_pos, to_global(cast_to), [], 128)
		if result:
			var w = our_pos.distance_to(result.position) / decal_cast_dist
			var decal_scale = lerp(min_max_decal_scale.x, min_max_decal_scale.y, w)
			EnvironmentDecalManager.place_blood_decal(result.position, result.normal, decal_scale)

func _process(_delta):
	if !emitting:
		queue_free()
