extends RayCast

export var min_max_tri_scale = Vector2(.2, .7)

func _ready():
	generate_tri()

func generate_tri():
	var space_state = get_world().direct_space_state
	var our_pos = global_transform.origin
	
	var result = space_state.intersect_ray(our_pos, to_global(cast_to), [], collision_mask)
	#print(result)
	if !result:
		$BloodTri.hide()
		return
	#face along normal
	var obj = $BloodTri
	obj.global_transform.origin = result.position + result.normal * 0.005
	var norm = result.normal
	var up = obj.global_transform.basis.y
	var x = norm.cross(Vector3.UP).normalized()
	if x == Vector3.ZERO:
		x = Vector3.RIGHT
	var y = norm.cross(x)
	
	obj.global_transform.basis = Basis(x,y, norm)
	
	var new_scale = rand_range(min_max_tri_scale.x, min_max_tri_scale.y)
	obj.scale = Vector3.ONE * new_scale
	
	var rotate_amnt = rand_range(0.0, 2 * PI)
	obj.global_rotate(norm, rotate_amnt)