shader_type spatial;
render_mode unshaded, depth_draw_alpha_prepass;
 
uniform sampler2D dist_tx : hint_albedo;
uniform sampler2D noise_tx : hint_albedo;
uniform sampler2D mask_tx : hint_albedo;

uniform sampler2D refl_blur_tx : hint_albedo;
uniform sampler2D refl_clear_tx : hint_albedo;

uniform vec4 tint_color : hint_color;
uniform float tint_amount = 0.1;

uniform float screen_pixel_sz = 0.001;
//uniform float bands = 2.0;

void fragment() {
	vec2 dist = texture(dist_tx, SCREEN_UV + TIME / 40.0).xy / 150.0;
	float blur_amnt = texture(noise_tx, dist + 0.5 * SCREEN_UV + TIME / vec2(-10.0, -20.0)).x;
	//blur_amnt = floor(blur_amnt * bands) / bands;
	//blur_amnt = step(blur_amnt, 0.15);
	blur_amnt = clamp(blur_amnt, 0.0, 0.5) / 0.5;
	vec2 uv = dist + vec2(1.0 - SCREEN_UV.x, SCREEN_UV.y);
	
	vec4 blur_col = texture(refl_blur_tx, uv) * 0.16;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, screen_pixel_sz)) * 0.15;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, -screen_pixel_sz)) * 0.15;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, 2.0 * screen_pixel_sz)) * 0.12;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, 2.0 * -screen_pixel_sz)) * 0.12;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, 3.0 * screen_pixel_sz)) * 0.09;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, 3.0 * -screen_pixel_sz)) * 0.09;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, 4.0 * screen_pixel_sz)) * 0.05;
	blur_col += texture(refl_blur_tx, uv + vec2(0.0, 4.0 * -screen_pixel_sz)) * 0.05;
	
	//vec3 col = mix(texture(refl_blur_tx, uv), texture(refl_clear_tx, uv), blur_amnt).xyz;
	//vec3 col = mix(mix(blur_col, texture(refl_clear_tx, uv), blur_amnt), tint_color, tint_amount).xyz;
	//vec3 col = texture(refl_clear_tx, uv).xyz;
	vec3 col = blur_col.xyz;
	float mask_val = texture(mask_tx, UV).r;
	ALBEDO = col;// * mask_val;
	ALPHA = clamp(100.0 * mask_val, 0.0, 1.0);
	//ALPHA_SCISSOR = 0.001;
}