shader_type spatial;
render_mode unshaded;

uniform sampler2D splash_texture;
uniform sampler2D noise_texture;
uniform float distort_amnt = 0.1;

void fragment() {
	vec2 dist = texture(noise_texture, UV + TIME * 0.6).xy * distort_amnt;
	vec4 col = texture(splash_texture, UV + dist - distort_amnt * 0.5); // subtract half of distort_amnt to prevent offset
	
	
	ALBEDO = col.rgb;
	ALPHA = col.a;
	ALPHA_SCISSOR = 0.01;
	
}