extends Node

const GRID_TABLES = {
	"bandit": [
		{"id": "lung_left", "rotated": false, "x":0, "y":0},
		{"id": "lung_right", "rotated": false, "x":2, "y":0},
		{"id": "heart", "rotated": false, "x":1, "y":0},
		{"id": "fat", "rotated": false, "x":1, "y":1},
		{"id": "fat", "rotated": false, "x":1, "y":2},
		{"id": "intestines", "rotated": false, "x":0, "y":3}
	],
	"error": []
	
}

const BAG_TABLES = {
	"chest": [
		{"id": "smg", "rotated": false, "x":0.5, "y":0.5}
	],
	"error": []
}

func get_table(id):
	if id in GRID_TABLES:
		return GRID_TABLES[id]
	if id in BAG_TABLES:
		return BAG_TABLES[id]
	return {}

func get_grid_table(id):
	if id in GRID_TABLES:
		return GRID_TABLES[id]
	else:
		return GRID_TABLES["error"]

func get_bag_table(id):
	if id in BAG_TABLES:
		return BAG_TABLES[id]
	else:
		return BAG_TABLES["error"]

func get_table_type(id):
	if id in BAG_TABLES:
		return "bag"
	if id in GRID_TABLES:
		return "grid"
	else:
		return "error"