# generic bullet, move forwards until hit something
# TODO set up an object pooling for this

extends KinematicBody

var damage = 0 # set by weapon
var speed = 100
var cur_lifetime = 0
const MAX_LIFETIME = 2

var last_position = Vector3()
var objects_to_ignore = []
#var collision_mask = 1
var shot_by = ""

var bullet_hit_effect = preload("res://items/weapons/effects/BulletHitEffect/BulletHitEffect.tscn")

func _ready():
	if shot_by == "player":
		speed *= 4
	$Graphics.hide()
	last_position = global_transform.origin

func set_objects_to_ignore(to_ignore: Array):
	objects_to_ignore = to_ignore

func _physics_process(delta):
	# move forward until hit something
	var collision = move_and_collide(global_transform.basis.z * delta * speed)
	if collision and not collision.collider in objects_to_ignore:
		if collision.collider.has_method("damage"):
			collision.collider.damage(damage, global_transform.basis.z)
		else:
			create_impact_vfx(collision.position, collision.normal)
		queue_free()
	
	cur_lifetime += delta
	if cur_lifetime > MAX_LIFETIME:
		queue_free()
	if cur_lifetime > 0.05:
		$Graphics.show()

func create_impact_vfx(pos, norm):
	var bh = bullet_hit_effect.instance()
	get_tree().get_root().add_child(bh)
	bh.global_transform.origin = global_transform.origin + Vector3(0, 1.0 * rand_range(-1.0, 1.0), 0.0)
	# move it back a little so it will project on the wall properly
	bh.init_effect()
	bh.show()
	bh.rotation_degrees.z = rand_range(0, 360)
	var dir = global_transform.basis.z
	bh.global_rotate(Vector3(0, 1, 0), atan2(dir.x, dir.z))
	var rand_y = Vector3(0.0, rand_range(-0.8, 0.8), 0.0)
	var rand_scale = rand_range(0.1, 0.5)
	EnvironmentDecalManager.place_hit_decal(pos + rand_y, norm, rand_scale)
