# spawns bullets and faces them in the right direction

extends Spatial

var bullet_rsrc = preload("res://items/weapons/projectiles/Bullet.tscn")

func fire(params: Dictionary):
	var bullet = (bullet_rsrc).instance()
	get_tree().get_root().add_child(bullet)
	bullet.damage = params.damage
	bullet.global_transform.origin = global_transform.origin
	bullet.global_transform.basis = global_transform.basis
	var fwd_vec : Vector3 = -global_transform.basis.z
	if "fire_point" in params:
		bullet.global_transform.origin = params.fire_point.global_transform.origin
		fwd_vec = params.fire_point.global_transform.basis.z
		fwd_vec = fwd_vec.rotated(Vector3.UP, rotation.y)
	bullet.global_transform.basis.z = fwd_vec
	bullet.set_objects_to_ignore(params.objects_to_ignore)
	bullet.shot_by = params.held_by

