extends CanvasLayer

var particle_mats_to_cache = [
	preload("res://effects/BloodSplatter/BloodSplatterParticleMat.tres"),
	preload("res://items/weapons/effects/BulletHitEffect/ThinSmokeParticlesParticleMat.tres"),
	preload("res://items/weapons/effects/BulletHitEffect/ThickSmokeParticlesParticleMat.tres"),
	preload("res://items/weapons/effects/BulletHitEffect/SparksParticlesParticleMat.tres"),
	preload("res://items/weapons/effects/MuzzleFlash/MuzzleThickSmokeParticleMat.tres"),
	preload("res://items/weapons/effects/MuzzleFlash/MuzzleThinSmokeParticleMat.tres"),
	preload("res://environment/puddles/materials/SplashEmitterMat.tres")
]

var particles = preload("res://singletons/GenericParticles.tscn")

var scenes_to_cache = [
	preload("res://items/weapons/projectiles/Bullet.tscn")
]

func _ready():
	for mat in particle_mats_to_cache:
		var particles_inst = particles.instance()
		particles_inst.set_process_material(mat)
		particles_inst.set_one_shot(true)
		particles_inst.set_emitting(true)
		add_child(particles_inst)


	for scn in scenes_to_cache:
		add_child(scn.instance())